/**
   CertVerify.java -- Unit test for certificates

   Copyright (C) 2001, RTFM, Inc.
   All Rights Reserved.

   ekr@rtfm.com  Tue Jan  9 12:11:17 2001
*/



package COM.claymoresystems.cert;

import java.io.*;
import java.util.*;
import COM.claymoresystems.crypto.*;
import COM.claymoresystems.ptls.SSLDebug;
import COM.claymoresystems.ptls.LoadProviders;

public class CertVerify {
     public static CertContext cctx=new CertContext();
     public static void loadRoots(String file) throws Exception {
       FileInputStream fis=new FileInputStream(file);

       BufferedReader br=new BufferedReader(new InputStreamReader(fis));

       for(;;){
	 byte[] root=WrappedObject.loadObject(br,"CERTIFICATE",null);

	 if(root==null)
	   break;
         cctx.addRoot(root);
       }
     }

     public static byte[] loadCert(String file) throws Exception {
       FileInputStream fis=new FileInputStream(file);
       BufferedReader br=new BufferedReader(new InputStreamReader(fis));

       byte[] cert=WrappedObject.loadObject(br,"CERTIFICATE",null);

       return(cert);
     }


     
     public static void main(String args[]) throws Exception {
       LoadProviders.init();
       loadRoots(args[0]);

       // SSLDebug.setDebug(SSLDebug.DEBUG_CERT | SSLDebug.DEBUG_CRYPTO);
       
       byte[] cert_ber=loadCert(args[1]);
       
       if(args.length==3) cert_ber[cert_ber.length-1]++;
       X509Cert cert=new X509Cert(cert_ber);
       
       Vector vec=new Vector();
       vec.addElement(cert);
       Vector vchain=X509Cert.verifyCertChain(cctx,vec,true);

       if(vchain.size()==1)
         System.out.println("IS ROOT! Didn't actually verify signature");
       else
         if(vchain==null){
         System.out.println("Couldn't verify chain");
       }
       else{
         System.out.println("Verified successfully");
       }
     }
}
