#
#    targets.mk
#
#    $Source: /usr/local/CVS/crypto/targets.mk,v $
#    $Revision: 1.4 $
#    $Date: 2001/11/29 19:34:13 $
#    $Name:  $
#    $Disclaimer$
#
#    Copyright (C) 2001, RTFM, Inc.
#    All Rights Reserved.
#
#    ekr@rtfm.com
#



#
#    CONFIGURE USER-DEFINED MAKE ENVIRONMENT
#
#    These fields are specified by the user.  The remainder of
#    this file is generated from this user-specified information.
#
# COM_CLAYMORESYSTEMS_CRYPTO_DEFINES:
#    cpp defines, with the -D flag preceeding each
#
# COM_CLAYMORESYSTEMS_CRYPTO_INCLUDES:
#    cpp include directories, with the -I flag preceeding each
#
# COM_CLAYMORESYSTEMS_CRYPTO_LIBNAME:
#    the library associated with this module directory, used in
#    most cases for debugging purposes
#
# COM_CLAYMORESYSTEMS_CRYPTO_LIBPATHS:
#    link-time directories to search for libraries, with the -L flag
#    preceeding each
#
# COM_CLAYMORESYSTEMS_CRYPTO_LIBRARIES:
#    link-time libraries, with the -l flag preceeding each
#
# COM_CLAYMORESYSTEMS_CRYPTO_LOCALFLAGS:
#    compile-time flags specific to compiling only the files in
#    this module directory--this variable should only be set in
#    extremely exceptional cases
#
# COM_CLAYMORESYSTEMS_CRYPTO_MAKEFILES:
#    the makefiles
#
# COM_CLAYMORESYSTEMS_CRYPTO_NOBUILD:
#    do not build this module as part of the main system
#
# COM_CLAYMORESYSTEMS_CRYPTO_PACKAGE:
#    the Java package name
#
# COM_CLAYMORESYSTEMS_CRYPTO_PREFIX:
#    defines the module name, which also serves as the
#    prefix for all the variable names defined in this file
#
# COM_CLAYMORESYSTEMS_CRYPTO_PROGRAMS:
#    programs to build
#
# COM_CLAYMORESYSTEMS_CRYPTO_SOURCES:
#    the source files to compile to object
#
COM_CLAYMORESYSTEMS_CRYPTO_DEFINES  =
COM_CLAYMORESYSTEMS_CRYPTO_INCLUDES  =
COM_CLAYMORESYSTEMS_CRYPTO_LIBNAME  =
COM_CLAYMORESYSTEMS_CRYPTO_LIBPATHS  =
COM_CLAYMORESYSTEMS_CRYPTO_LIBRARIES  =
COM_CLAYMORESYSTEMS_CRYPTO_LOCALFLAGS  =
COM_CLAYMORESYSTEMS_CRYPTO_MAKEFILES  =
COM_CLAYMORESYSTEMS_CRYPTO_NOBUILD  =
COM_CLAYMORESYSTEMS_CRYPTO_PACKAGE  = COM.claymoresystems.crypto 
COM_CLAYMORESYSTEMS_CRYPTO_PREFIX  = COM_CLAYMORESYSTEMS_CRYPTO 
COM_CLAYMORESYSTEMS_CRYPTO_PROGRAMS  =
COM_CLAYMORESYSTEMS_CRYPTO_SOURCES  = BaseDSAPrivateKey.java BaseDSAPublicKey.java \
                            DHPrivateKey.java DHPublicKey.java \
                            EAYEncryptedPrivateKey.java \
                            HMACInputStream.java HMACOutputStream.java \
                            PEMData.java PKCS1Pad.java RandomStore.java \
                            RawDSAParams.java RawDSAPublicKey.java 



#
#    CONFIGURE AUTOMATICALLY-GENERATED MAKE ENVIRONMENT
#
# COM_CLAYMORESYSTEMS_CRYPTO_SOURCEFILES:
#     
#    qualified names of the sources
#
# COM_CLAYMORESYSTEMS_CRYPTO_OBJECTS:
#    object files to build
#
# COM_CLAYMORESYSTEMS_CRYPTO_UNUSED:
#    obsolete files in the module directory that are not
#    used during the build process
#
# COM_CLAYMORESYSTEMS_CRYPTO_USED:
#    all files in the module directory that are used
#    during the build process
#
COM_CLAYMORESYSTEMS_CRYPTO_SOURCEFILES  = ${SRCROOTDIR}COM/claymoresystems/crypto/BaseDSAPrivateKey.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/BaseDSAPublicKey.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/DHPrivateKey.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/DHPublicKey.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/EAYEncryptedPrivateKey.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/HMACInputStream.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/HMACOutputStream.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/PEMData.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/PKCS1Pad.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/RandomStore.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/RawDSAParams.java \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/RawDSAPublicKey.java 
COM_CLAYMORESYSTEMS_CRYPTO_OBJECTS  = ${SRCROOTDIR}COM/claymoresystems/crypto/BaseDSAPrivateKey.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/BaseDSAPublicKey.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/DHPrivateKey.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/DHPublicKey.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/EAYEncryptedPrivateKey.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/HMACInputStream.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/HMACOutputStream.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/PEMData.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/PKCS1Pad.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/RandomStore.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/RawDSAParams.class \
                            ${SRCROOTDIR}COM/claymoresystems/crypto/RawDSAPublicKey.class 
COM_CLAYMORESYSTEMS_CRYPTO_CLASSES  = COM.claymoresystems.crypto.BaseDSAPrivateKey \
                            COM.claymoresystems.crypto.BaseDSAPublicKey \
                            COM.claymoresystems.crypto.DHPrivateKey \
                            COM.claymoresystems.crypto.DHPublicKey \
                            COM.claymoresystems.crypto.EAYEncryptedPrivateKey \
                            COM.claymoresystems.crypto.HMACInputStream \
                            COM.claymoresystems.crypto.HMACOutputStream \
                            COM.claymoresystems.crypto.PEMData \
                            COM.claymoresystems.crypto.PKCS1Pad \
                            COM.claymoresystems.crypto.RandomStore \
                            COM.claymoresystems.crypto.RawDSAParams \
                            COM.claymoresystems.crypto.RawDSAPublicKey 
COM_CLAYMORESYSTEMS_CRYPTO_UNUSED  =
COM_CLAYMORESYSTEMS_CRYPTO_USED  =
SOURCEFILES += ${COM_CLAYMORESYSTEMS_CRYPTO_SOURCEFILES}
OBJECTS += ${COM_CLAYMORESYSTEMS_CRYPTO_OBJECTS}
CLASSES += ${COM_CLAYMORESYSTEMS_CRYPTO_CLASSES}
PACKAGES += ${COM_CLAYMORESYSTEMS_CRYPTO_PACKAGE}
